unit AlertUtils;

interface

	uses
{$IFC UNDEFINED THINK_PASCAL}
		Types, Dialogs, TextUtils, QuickDraw, Processes;
{$ELSEC}
		InterfacesUI;
{$ENDC}

{ Requires resource file 'MyErrors.rsrc' to be added to the project }

	const
		rFatalError = 600;
		errRequireSys7 = 1;
		errNoMenuBar = 2;
		errInitError = 3;
		errNotEnoughMemToStart = 4;
		errNotEnoughMemLeft = 5;
		errRescueFolder = 6;
		errNotEnoughMemToStartCont = 7;
		errCorruptPrefs = 8;

		rProblemError = 610;
		errGenericProblem = 0;
		errLowMemory = 1;
		errNoMemCut = 2;
		errNoWindowMemory = 7;
		errNoMatrixMemory = 8;
		errNoTextGT32K = 9;
		errReadFile = 13;

	procedure ProblemAlert (errNumber, language: Integer;
									extra1, extra2: Str255);

	procedure DeathAlert (errNumber, language: Integer);

implementation

	procedure ProblemAlert (errNumber, language: Integer;
									extra1, extra2: Str255);
		var
			theMessage: Str255;
	begin
		if errNumber > errGenericProblem then
			GetIndString(theMessage, rProblemError + language, errNumber)
		else
			theMessage := '';

{$IFC UNDEFINED THINK_PASCAL}
		SetCursor(qd.arrow);
{$ELSEC}
		SetCursor(arrow);
{$ENDC}
		ParamText(theMessage, extra1, extra2, '');
		if Alert(rProblemError + language, nil) = ok then
			;
	end; { Probleme }


	procedure DeathAlert (errNumber, language: Integer);
		var
			theMessage, s1, s2: Str255;
	begin
		GetIndString(theMessage, rFatalError + language, errNumber);
		if errNumber = errNotEnoughMemLeft then begin { More complex message in this case }
			GetIndString(s1, rFatalError + language, errRescueFolder);
			GetIndString(s2, rFatalError + language, errNotEnoughMemToStartCont);
		end
		else begin
			s1 := '';
			s2 := '';
		end;
		ParamText(theMessage, s1, s2, '');
		if Alert(rFatalError + language, nil) = ok then
			;
		ExitToShell;
	end; { Probleme }


end. { Unit AlertUtils }