{Some selected dialog utilities from my private library}
{Note: These are considerably safer than most similar dialog units I have seen, since they check}
{the item kind rather than just blindly assuming that the programmer know what he/she is doing.}

unit DialogUtils;

interface

	uses
{$IFC undefined THINK_PASCAL}
		Types, Quickdraw, Memory, Dialogs, Events, Controls, ToolUtils, TextUtils, OSUtils, Resources, Sound;
{$ELSEC}
		InterfacesUI;
{$ENDC}

	procedure HighlightDItem (theDialog: DialogPtr;
									itemNo: integer);
	procedure HiliteDItem (theDialog: DialogPtr;
									itemNo: integer);
	procedure EnableDItem (theDialog: DialogPtr;
									itemNo: integer);
	procedure DisableDItem (theDialog: DialogPtr;
									itemNo: integer);
	function TestDItemEnable (theDialog: DialogPtr;
									itemNo: integer): boolean;
	procedure HideDItem (theDialog: DialogPtr;
									itemNo: integer);
	procedure ShowDItem (theDialog: DialogPtr;
									itemNo: integer);
	procedure UpdDialogRect (theDialog: DialogPtr;
									theRect: Rect);
	procedure SetTextDItem (theDialog: DialogPtr;
									itemNo: integer;
									theString: Str255);
	function GetTextDItem (theDialog: DialogPtr;
									itemNo: integer): Str255;
	procedure SetBooleanDItem (theDialog: DialogPtr;
									itemNo: integer;
									theBoolean: Boolean);
	function GetBooleanDItem (theDialog: DialogPtr;
									itemNo: integer): Boolean;
	function GetIntegerDItem (theDialog: DialogPtr;
									itemNo: integer): Integer;
	procedure SetIntegerDItem (theDialog: DialogPtr;
									itemNo: integer;
									value: Integer);
	procedure ToggleBooleanDItem (theDialog: DialogPtr;
									itemNo: integer);
	function GetDItemBox (theDialog: DialogPtr;
									itemNo: integer): Rect;
	function GetDItemRefCon (theDialog: DialogPtr;
									itemNo: integer): LongInt;
	procedure SetDItemRefCon (theDialog: DialogPtr;
									itemNo: integer;
									refCon: LongInt);
	procedure FlashDialogItem (dlg: DialogPtr;
									itemToFlash: Integer);
	function OptionKeyDown: Boolean;

	function InsertOnTheFlyMenuFromSTR (STRid, Menuid, language: Integer): MenuHandle;

	procedure RemoveOnTheFlyMenu (menuid: Integer;
									theMenu: MenuHandle);

	function GetLongintTextDItem (theDialog: DialogPtr;
									itemNo: integer): LongInt;

implementation


	procedure HighlightDItem (theDialog: DialogPtr;
									itemNo: integer);
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else
			HiliteControl(ControlHandle(item), 1); {10 fr button, 11 fr radio?}
	end;

	procedure HiliteDItem (theDialog: DialogPtr;
									itemNo: integer);
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else
			HiliteControl(ControlHandle(item), 1); {10 fr button, 11 fr radio?}
	end;

	procedure EnableDItem (theDialog: DialogPtr;
									itemNo: integer);
		var
			kind, realkind: integer;
			item: Handle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, item, box);
		if item = nil then
			SysBeep(1)
		else begin
			realkind := BitAnd(kind, 127);
			case realkind of
				8, 16: {statText, editText}
					SetDialogItem(theDialog, itemNo, realkind, item, box); {meningslst?}
				0, 1, 2, 4, 5, 6, 7: {button, checkbox, radio, popup menu - men vad r 4?}
					HiliteControl(ControlHandle(item), 0);
				otherwise
					SysBeep(1);
			end; {case}
		end;
	end;

	procedure DisableDItem (theDialog: DialogPtr;
									itemNo: integer);
		var
			kind, realkind: integer;
			item: Handle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, item, box);
		if item = nil then
			SysBeep(1)
		else begin
			realkind := BitAnd(kind, 127);
			case realkind of
				8, 16: {statText, editText}
					SetDialogItem(theDialog, itemNo, kind + itemDisable, item, box); {meningslst?}
				0, 1, 2, 4, 5, 6, 7: {button, checkbox, radio, popup menu - men vad r 4?}
					HiliteControl(ControlHandle(item), 255);
				otherwise
					SysBeep(1);
			end; {case}
		end;
	end;

	function TestDItemEnable (theDialog: DialogPtr;
									itemNo: integer): boolean;
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else
			TestDItemEnable := ControlHandle(item)^^.contrlHilite <> 255;
	end;

	procedure HideDItem (theDialog: DialogPtr;
									itemNo: integer);
		var
			kind, realkind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else begin
			realkind := BitAnd(kind, 127);
			case realkind of
				8, 16: {statText, editText}
					SetDialogItemText(Handle(item), ''); {Nn bttre metod finns vl}
				0, 1, 2, 4, 5, 6: {button, checkbox, radio - men vad r 4?}
					HideControl(ControlHandle(item));
				otherwise
					SysBeep(1);
			end; {case}
		end;
	end;

	procedure ShowDItem (theDialog: DialogPtr;
									itemNo: integer);
		var
			kind, realkind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else begin
			realkind := BitAnd(kind, 127);
			case realkind of
				8, 16: 
					; {statText, editText}
				0, 1, 2, 4, 5, 6: {button, checkbox, radio - men vad r 4?}
					ShowControl(ControlHandle(item));
				otherwise
					SysBeep(1);
			end; {case}
		end;
	end;

{UpdDialog med rektangel i stllet fr region}
	procedure UpdDialogRect (theDialog: DialogPtr;
									theRect: Rect);
		var
			rgn: RgnHandle;
	begin
		rgn := NewRgn;
		RectRgn(rgn, theRect);
		UpdateDialog(theDialog, rgn);
		DisposeRgn(rgn);
	end;

{Ett par triviala tvradare - plus skerhetskoll!}
{Text till StatText/EditText}
	procedure SetTextDItem (theDialog: DialogPtr;
									itemNo: integer;
									theString: Str255);
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else begin
{Kolla kind}
			kind := BitAnd(kind, 127);

			case kind of
				8, 16: {statText, editText}
					SetDialogItemText(handle(item), theString);
				0, 1, 2, 4, 5, 6: {button, checkbox, radio - men vad r 4?}
					SetControlTitle(item, theString);
				otherwise {vriga har ingen text man kan stta}
					SysBeep(1);
			end;{case}
		end;
	end;

{Texten frn StatText/EditText}
	function GetTextDItem (theDialog: DialogPtr;
									itemNo: integer): Str255;
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
			tmpStr: Str255;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else begin
{Kolla kind}
			kind := BitAnd(kind, 127);

			tmpStr := '';
			case kind of
				8, 16: {statText, editText}
					GetDialogItemText(handle(item), tmpStr);
				0, 1, 2, 4, 5, 6: {button, checkbox, radio?}
					GetControlTitle(item, tmpStr);
				otherwise {vriga har ingen text man kan stta}
					SysBeep(1);
			end;{case}
			GetTextDItem := tmpStr;
		end;
	end;


{Ett par triviala tvradare - plus skerhetskoll!}
{Boolean till checkbox/radio}
	procedure SetBooleanDItem (theDialog: DialogPtr;
									itemNo: integer;
									theBoolean: Boolean);
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else begin
{Kolla kind}
			kind := BitAnd(kind, 127);
			case kind of
				8, 16: {statText, editText}
					if theBoolean then
						SetDialogItemText(handle(item), 'true')
					else
						SetDialogItemText(handle(item), 'false');
				0, 1, 2, 4, 5, 6: {button, checkbox, radio - men vad r 4?}
					SetControlValue(item, integer(theBoolean));
				otherwise {vriga har ingen text man kan stta}
					SysBeep(1);
			end;{case}
		end;
	end;

{Boolean frn checkbox/radio}
	function GetBooleanDItem (theDialog: DialogPtr;
									itemNo: integer): Boolean;
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else begin
{Kolla kind}
			kind := BitAnd(kind, 127);

			GetBooleanDItem := false;
			case kind of
				0, 1, 2, 4, 5, 6: {button, checkbox, radio?}
					GetBooleanDItem := boolean(GetControlValue(item));
				otherwise {vriga har inget vrde}
					SysBeep(1);
			end;{case}
		end;
	end;

	procedure ToggleBooleanDItem (theDialog: DialogPtr;
									itemNo: integer);
	begin
		SetBooleanDItem(theDialog, itemNo, not GetBooleanDItem(theDialog, itemNo));
	end;

	function GetDItemBox (theDialog: DialogPtr;
									itemNo: integer): Rect;
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		GetDItemBox := box;
	end;

{Get any control's value}
	function GetIntegerDItem (theDialog: DialogPtr;
									itemNo: integer): Integer;
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else begin
			kind := BitAnd(kind, 127);

			GetIntegerDItem := 0;
			case kind of
				0, 1, 2, 4, 5, 6, 7: {button, checkbox, radio, popup?}
					GetIntegerDItem := GetControlValue(item);
				otherwise
					SysBeep(1);
			end;{case}
		end;
	end;

	procedure SetIntegerDItem (theDialog: DialogPtr;
									itemNo: integer;
									value: Integer);
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		if item = nil then
			SysBeep(1)
		else begin
			kind := BitAnd(kind, 127);

			case kind of
				0, 1, 2, 4, 5, 6, 7: {button, checkbox, radio, popup?}
					SetControlValue(item, value);
				otherwise
					SysBeep(1);
			end;{case}
		end;
	end;

	procedure FlashDialogItem (dlg: DialogPtr;
									itemToFlash: Integer);
		var
			iKind: Integer;
			iHandle: Handle;
			iRect: Rect;
			ignored: LongInt;
	begin
		GetDialogItem(dlg, itemToFlash, iKind, iHandle, iRect);
		HiliteControl(ControlHandle(iHandle), 1);
		Delay(10, ignored);
		HiliteControl(ControlHandle(iHandle), 0);
	end; { procedure FlashDialogItem }

	function OptionKeyDown: Boolean;
		var
			er: EventRecord;
			optKey: Boolean;
	begin
		optKey := OSEventAvail(everyEvent, er);
		optKey := BAND(er.modifiers, optionKey) <> 0;
		OptionKeyDown := optKey;
	end; { OptionKeyDown }

{ This procedure replaces the contents of a menu with that of a STR# resource }
{ This is very handy when you have information in a STR# resource that you would like }
{ to display in, say a popup menu, but you don't want to have two copies of the same }
{ information (one in the menu, one in the STR#) }
{ The host must call RemoveOnTheFlyMenu when done with this menu }
{ The language parameter is added to the STR# id to allow for easy localization. It }
{ is assumed that the MENU id does not require localization, since the resulting }
{ menu will be localized by the time this function is done. }
	function InsertOnTheFlyMenuFromSTR (STRid, Menuid, language: Integer): MenuHandle;
		var
			theMenu: MenuHandle;
			i: Integer;
			s: Str255;
	begin
		theMenu := GetMenu(Menuid);
		InsertMenu(theMenu, -1);
		for i := 1 to CountMItems(theMenu) do { Effacer tout le menu }
			DeleteMenuItem(theMenu, 1);

		i := 1;
		repeat
			GetIndString(s, STRid + language, i); { will return empty string when out of range }
			if s <> '' then begin
				InsertMenuItem(theMenu, s, i); { Mettre 'toto' pour viter les metachars }
				SetMenuItemText(theMenu, i, s); { Doit faire les deux pour viter les metachars }
			end;
			i := i + 1;
		until s = '';

		InsertOnTheFlyMenuFromSTR := theMenu;
	end; { InsertOnTheFlyMenuFromSTR }

	procedure RemoveOnTheFlyMenu (menuid: Integer;
									theMenu: MenuHandle);
	begin
		DeleteMenu(menuid);
		ReleaseResource(Handle(theMenu));
	end; { RemoveOnTheFlyMenu }

{ Get/Set any control's refcon }
	function GetDItemRefCon (theDialog: DialogPtr;
									itemNo: integer): LongInt;
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		GetDItemRefCon := GetControlReference(item);
	end; { GetDItemRefCon }
	procedure SetDItemRefCon (theDialog: DialogPtr;
									itemNo: integer;
									refCon: LongInt);
		var
			kind: integer;
			item: ControlHandle;
			box: Rect;
	begin
		GetDialogItem(theDialog, itemNo, kind, Handle(item), box);
		SetControlReference(item, refCon);
	end; { GetDItemRefCon }

	function GetLongintTextDItem (theDialog: DialogPtr;
									itemNo: integer): LongInt;
		var
			s: Str255;
			l: LongInt;
	begin
		s := GetTextDItem(theDialog, itemNo);
		StringToNum(s, l);
		GetLongintTextDItem := l;
	end; { GetLongIntTextDItem }

end.