program PermuteMain;

{ 3.4a6: corrected some minor UI glitches: double saves, scroll bars in text windows. }
{        deactivated stepwise button until I have time to implement it. }
{ Version 3.4: complete rewrite using TransSkel 2.6 and PowerPC code }
{              Use dynamic memory }

{ Version 3.2 - Multiple Regression tested with permutations, with ter Braak correction }
{ Part of the code is from 'SuperMantel' and 'Procruste'.    }

{ 3.1.1: Program now works correctly with System 6 }
{ 3.2: ter Braak correction (F-tests) }

	uses
{$IFC not undefined THINK_PASCAL}
		InterfacesUI, 
{$ELSEC}
		Types, Quickdraw, Memory, Dialogs, Events, Controls, GestaltEqu, Menus,{}
		Windows, OSUtils, ToolUtils, QuickDrawText, TextUtils, StandardFile, Lists, {}
{$ENDC}
		Printing, TransSkel, TransDisplay, FileUtils, DialogUtils, Assertions, {}
{$ifc can_use_threads}
		Threads, 
{$endc}
		MathDeclarations, MatrixAlgebra, Statistiques, PermutePrefs, Permutations, {}
		PermuteProgressInfo, TestsParPermutation;

	const
		notDrawn = FALSE;  (* symbolic constants used to make LNew() more readable *)
		noGrow = FALSE;
		noHScroll = FALSE;
		hScroll = TRUE;
		vScroll = TRUE;

		kHeaderHeight = 40; { Height in pixels of the info header in data windows }
		kHOffset = 15;
		kVOffset = 2; { Horizontal/vertical offsets in pixels of info header }

		kPrintHeaderHeight = 40;
		kPrintInset = 5; { How many pixels to inset the printing rectangle }

		kSignature = 'Rmar';

		kStubLDEF = 128; { Stub LDEF }
		kRootObjMenu = 40;
		kpToRemoveMenu = 50;
		kpToEnterMenu = 51;
		i10 = 1;
		i05 = 2;
		i01 = 3;
		i001 = 4;
		kFileMenuRes = 128;		{MENU resource id}
		iNew = 1;
		iOpen = 2;
		iClose = 3;
		iSave = 5;
		iPageSetup = 7;
		iPrint = 8;
		iQuit = 10;
		kEditMenuRes = 129;
		iUndo = 1;
		iCut = 3;
		iCopy = 4;
		iPaste = 5;
		iClear = 6;
		iSelectAll = 7;
		iPreferences = 9;

		kAboutRes = 129;		{ALRT resource id}
		kFileWinRes = 128;		{WIND resource id}
		kDisplayWinRes = 129;	{WIND resource id}
		kRegDlogRes = 133;		{DLOG resource id}
		iQuickTest = 3;
		iPermVect = 4;
		iPermMat = 5;
		iPermDPT = 6;
		iPermTPT = 7;
		iRootingObj = 8;
		iNbPerm = 9;
		iTestSimple = 10;
		iTestBack = 11;
		iTestForw = 12;
		iTestStep = 13;
		ipToRemove = 14;
		ipToEnter = 15;
		iIndependentList = 16;
		iDependentList = 17;
		iQuickResults = 18;
{ Strings }
		kResStrings = 128;
		kResAboutStr = 1;
		knaStr = 2;
		kQuickTestMessage = 3;
		kVariableStr = 4;
		kStdCoeffStr = 5;
		ktValueStr = 6;
		kpValueStr = 7;
		kSeparator = 8;
		kRSquared = 9;
		kPermutationProgress = 10;
		kPermutationDone = 11;

		kFileWindowStrings = 129;
		kLinesStr = 1;
		kColumnsStr = 2;
		kNbObjectsStr = 3;
		kSaveFilePromptStr = 4;

	type
		WindowInfo = record { What to put in a file window's RefCon }
				owner: OSType;
				matrix: TMatrixPtr;
				list: ListHandle;
			end; { WindowInfo }
		WindowInfoPtr = ^WindowInfo;

	var
		gFileMenu, gEditMenu: MenuHandle;
		gColorFlag, gHas68kFPU: Boolean;
		gNbPerm: TInteger;
		gRegDlg: DialogPtr;
		gCurPermMeth, gCurTestMeth: Integer;
		gXVarSel, gYVarSel, gQuickTest: ListHandle;
		gClipRgn: RgnHandle;
		gListFont, gListSize, gNbDecimales: Integer;
		gPageSetup: THPrint; { Page Setup record }
		gUseThreads: Boolean;

	procedure MatrixDisplayLDEF (message: integer;
									selected: boolean;
									var cellRect: Rect;
									theCell: Cell;
									dataOffset, dataLen: integer;
									theList: ListHandle);
		var
			savedPenState: PenState;
			s: Str255;
			col: TInteger;
			wInfo: WindowInfoPtr;
			oldFace: Style;
			oldFont, oldSize: Integer;

		procedure MatrixDisplayLDEFHighlight (selected: Boolean;
										cellRect: Rect;
										theCell: Cell;
										dataOffset: Integer;
										dataLen: Integer;
										theList: ListHandle);

			const
{ Low-memory global }
				HiliteMode = $938;              {[GLOBAL VAR]  used for color highlighting}
{ From Universal Interfaces Quickdraw.p }
				pHiliteBit = 0;							{flag bit in HiliteMode used with BitClr procedure}

{$UNUSED selected, theCell, dataOffset, dataLen, theList}

		begin
			BitClr(Ptr(HiliteMode), pHiliteBit); {use color highlighting if possible}
			InvertRect(cellRect);								{highlight cell rectangle}
		end;

	begin
		wInfo := WindowInfoPtr(WindowPeek(theList^^.port)^.refCon);
		Assert(wInfo^.owner = kSignature);

		case message of
			lInitMsg:  begin

			end; { lInitMsg }

			lDrawMsg:  begin
				GetClip(gClipRgn);
				ClipRect(cellRect);
				GetPenState(savedPenState);
				PenNormal;
				EraseRect(cellRect);
				TextFont(gListFont);
				TextSize(gListSize);

				MoveTo(cellRect.left, cellRect.bottom - 2);
				col := theCell.h + 1; { Colonne, car la liste commence  0,0 et nous on veut 1,0 }
				if theCell.v = 0 then begin { en-tte de colonne }
					s := GetColName(wInfo^.matrix, col);
{$IFC not undefined THINK_PASCAL}
					oldFont := thePort^.txFont;
					oldSize := thePort^.txSize;
					oldFace := thePort^.txFace;
			{$elsec}
					oldFont := qd.thePort^.txFont;
					oldSize := qd.thePort^.txSize;
					oldFace := qd.thePort^.txFace;
			{$endc}
					TextFont(applFont); { Geneva }
					TextSize(9);
					TextFace([bold]);
					DrawString(s);
					TextFace(oldFace);
					TextFont(oldFont);
					TextSize(oldSize);
				end
				else begin { Donnes de la matrice }
					s := StringOf(GetElement(wInfo^.matrix, theCell.v, col) : gNbDecimales + 2 : gNbDecimales);
					DrawString(s);
				end;
				MoveTo(cellRect.right - 2, cellRect.top);
				LineTo(cellRect.right - 2, cellRect.bottom);

				if selected then											{highlight cell}
					MatrixDisplayLDEFHighlight(selected, cellRect, theCell, dataOffset, dataLen, theList);

	{restore graphics environment}
				SetPenState(savedPenState);											{restore pen state}
				SetClip(gClipRgn);
			end; { lDrawMsg }

			lHiliteMsg:  begin
				MatrixDisplayLDEFHighlight(selected, cellRect, theCell, dataOffset, dataLen, theList);
			end; { lHiliteMsg }

			lCloseMsg:  begin
			end; { lCloseMsg }
			otherwise
				;
		end; {case}
	end; { MatrixDisplayLDEF }

{ Faire un test rapide de rgression multiple, sans les permutations }
	procedure DoQuickTest (mat: TMatrixPtr;
									whichXVariables, whichYVariable: TBoolVectorPtr);
		var
			i, j: TInteger;
			theCell, sourceCell: Point;
			x, y, b, t: TMatrixPtr;
			firstRow, newWidth, nameLen: Integer;
			s: Str255;
			rCarre, probTj, tj: TReal;
			curFont, curSize: Integer;
			result: Boolean;
	begin
		SetCursor(GetCursor(watchCursor)^^);
{ Create the vector of booleans indicating which variables are selected }
		Assert(mat <> nil);
		Assert(whichXVariables <> nil);
		Assert(whichYVariable <> nil);

		x := nil;
		y := nil;

		SubMatrix(mat, x, whichXVariables, false);

		SubMatrix(mat, y, whichYVariable, false);

{$ifc do_debugfiles}
		writeln(debug1, 'Vecteur y');
		for j := 1 to y^.n do
			writeLn(debug1, GetElement(y, j, 1) : 8 : 6);
		writeln(debug1);
		writeln(debug1, 'Matrice X');
		for i := 1 to x^.p do begin
			for j := 1 to x^.n do
				write(debug1, GetElement(x, j, i) : 8 : 6, '    ');
			writeln(debug1);
		end;
{$endc}

		b := nil;
		t := nil; { Je veux que la procdure cre ces matrices }
		result := RegressionMultiple(y, x, b, t, rCarre, nil, Besoin_Centrer_Reduire);
		if result then begin
{ Modify the list to contain these results }
			LSetDrawingMode(false, gQuickTest);

			LDelColumn(0, 1, gQuickTest);
			LDelRow(0, 1, gQuickTest); { effacer les donnes dj prsentes, s''il y a lieu }

{ On ajoute 4 colonnes: nom de la variable, coeff. normalis, t de Student, probabilit }
{ Chaque colonne a une en-tte approprie  la ligne 0 }
			firstRow := LAddColumn(4, 0, gQuickTest);

			firstRow := LAddRow(b^.n + 1 + 2, 0, gQuickTest); (* +1 b/c 0 is the header *)
(* +2 for 2 more lines to write r^2 *)

{ Installer les en-ttes }
			curFont := gRegDlg^.txFont;
			curSize := gRegDlg^.txSize;
			TextFont(gListFont);
			TextSize(gListSize);
			newWidth := 0; { Pour calculer la nouvelle largeur de cellule }
			for j := 0 to 3 do begin { Une boucle plutt que de rpter 4 fois la mme chose }
				SetPt(theCell, j, 0);
				GetIndString(s, kResStrings, kVariableStr + j);
				firstRow := StringWidth(s);
				if StringWidth(s) > newWidth then
					newWidth := StringWidth(s);
				LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gQuickTest);
			end; { for j }

			SetPt(sourceCell, 0, 0);
			for j := 1 to b^.n do begin
{ Noms de variable }
				if (LGetSelect(true, sourceCell, gXVarSel)) then begin
					nameLen := 255;  (* The maximum number of chars allowed in the string *)
					LGetCell(POINTER(ORD(@s) + 1), nameLen, sourceCell, gXVarSel);        (* Get the text of the selected cell *)
   {$PUSH}
  {$R- Turn off range checking for the next operation, since Pascal doesn't like you to change the string length byte }
					s[0] := CHR(nameLen);                        (* Set the length byte of the string *)
     {$POP Range checking is back on}
					sourceCell.v := sourceCell.v + 1; { Descendre de 1 }
				end;
				SetPt(theCell, 0, j); (* select the proper cell *)
				LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gQuickTest); (* and copy the information into it *)

{ Vecteur b }
				SetPt(theCell, 1, j);
				s := StringOf(b^.col^[1].data^[j] : gNbDecimales + 2 : gNbDecimales);
				if b^.col^[1].data^[j] > 0 then
					s := Concat(' ', s); { ajouter un espace }
				LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gQuickTest);

{ Vecteur t }
				SetPt(theCell, 2, j);
				s := StringOf(t^.col^[1].data^[j] : gNbDecimales + 2 : gNbDecimales);
				if t^.col^[1].data^[j] > 0 then
					s := Concat(' ', s); { ajouter un espace }
				LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gQuickTest);

{ Vecteur de probabilits }
				SetPt(theCell, 3, j);
				tj := GetElement(t, j, 1);
{ Profitons du fait que la table F pour nu1 = 1 quivaut  la table t leve au carr }
{ Mod. PhC 28.10.98: division de la probabilit du t par 2 pour avoir un prob. unilatrale }
{ tel que calcul par le test par permutations }
				probTj := PoF(tj * tj, 1, x^.n - x^.p - 1) / 2;
				s := StringOf(probTj : gNbDecimales + 2 : gNbDecimales);
				LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gQuickTest);

			end;

{ Ligne de sparation entre les variables et le r^2 }
			GetIndString(s, kResStrings, kSeparator);
			for i := 0 to 1 do begin { boucle pour viter de rpter }
				SetPt(theCell, i, j);
				LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gQuickTest);
			end;
{ crire le r^2 }
			j := j + 1;
			SetPt(theCell, 0, j);
			GetIndString(s, kResStrings, kRSquared);
			LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gQuickTest);
			SetPt(theCell, 1, j);
			s := StringOf(rCarre : gNbDecimales + 2 : gNbDecimales);
			LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gQuickTest);


			SetPt(theCell, newWidth, gQuickTest^^.cellSize.v);
			LCellSize(theCell, gQuickTest); { Change default cell size }
			LSetDrawingMode(true, gQuickTest); (* we turn drawing back on *)
			InvalRect(GetDItemBox(gRegDlg, iQuickResults));
			TextFont(curFont);
			TextSize(curSize);
		end; { if result }
		DisposeMatrix(x);
		DisposeMatrix(y);
		DisposeMatrix(b);
		DisposeMatrix(t);

{$IFC not undefined THINK_PASCAL}
		SetCursor(arrow);
{$elsec}
		SetCursor(qd.arrow);
{$endc}
	end; { DoQuickTest }

{ This function tests if the user has selected enough information to do the analysis }
	function TestConditions (mat: TMatrixPtr): Boolean;
		var
			j, numX: Integer;
			oneY: Boolean;
			theCell: Point;
	begin
		Assert(mat <> nil);
		numX := 0;
		for j := 1 to mat^.p do begin
			SetPt(theCell, 0, j - 1); { 0-based list indices }
			if (LGetSelect(false, theCell, gXVarSel)) then
				numX := numX + 1;
		end; { for j }
		SetPt(theCell, 0, 0);
		oneY := LGetSelect(true, theCell, gYVarSel);
		TestConditions := (numX > 0) and oneY;
	end; { TestConditions }

	procedure RegressionWindowClose;
	begin
		LDispose(gXVarSel);
		gXVarSel := nil;
		LDispose(gYVarSel);
		gYVarSel := nil;
		LDispose(gQuickTest);
		gQuickTest := nil;
		SkelRmveDlog(gRegDlg);
		DisposeWindow(gRegDlg);
		gRegDlg := nil;
	end; { RegressionWindowClose }

	procedure CloseFrontWindow;
		var
			w: WindowPtr;
			wInfo, rInfo: WindowInfoPtr;
	begin
		w := FrontWindow;
		if w <> nil then begin
			if w = gRegDlg then begin { close the regression dialog }
				RegressionWindowClose;
			end
			else if IsDWindow(w) then { Close a display window }
				SkelRmveWind(w)
			else begin {close a data window}
				wInfo := WindowInfoPtr(WindowPeek(w)^.refCon);
				if (wInfo <> nil) and (wInfo^.owner = kSignature) then begin { close a data window }
					rInfo := nil;
					if (gRegDlg <> nil) then begin { figure out what data the reg. dialog is using }
						rInfo := WindowInfoPtr(WindowPeek(gRegDlg)^.refCon);
						Assert(rInfo^.owner = kSignature);
					end;
					if (wInfo = rInfo) then
						RegressionWindowClose;
					DisposeMatrix(wInfo^.matrix);
					LDispose(wInfo^.list);
					DisposePtr(Ptr(wInfo));
					SkelRmveDlog(w);
					DisposeWindow(w);
				end { close a data window }
				else begin { close a generic/display window }
					SkelRmveWind(w);
				end;
			end;
		end; { if <>nil }
	end; { CloseFrontWindow }

	procedure DWindowProgress;
		var
			r, prog: rect;
			f, s: Integer;
			msg: Str255;
			port: GrafPtr;
	begin
{$IFC not undefined THINK_PASCAL}
		port := thePort;
		f := thePort^.txFont;
		s := thePort^.txSize;
{$ELSEC}
		port := qd.thePort;
		f := qd.thePort^.txFont;
		s := qd.thePort^.txSize;
{$ENDC}
		r := port^.portRect;
		r.bottom := r.top + kProgressBannerHeight;
		r.right := r.right - 15; { account for scroll bar }
{ Draw a horizontal line }
		MoveTo(r.left, r.bottom - 1);
		Line((r.right - r.left), 0);

		InsetRect(r, 1, 1);
		GetClip(gClipRgn);
		ClipRect(r);
		EraseRect(r);

{ Frame progress rectangle }
		CalculateProgressRect(prog, port);
		InsetRect(prog, -1, -1);
		FrameRect(prog);

{ Get the message string }
		GetIndString(msg, kResStrings, kPermutationProgress);

		TextFont(applFont); { Geneva }
		TextSize(9);
		MoveTo(r.left + 2 * kProgressOffset + kProgressLength, r.bottom - 2);
		DrawString(msg);

		with r do { find progress rect and frame it }
			right := left + kProgressLength;

		SetClip(gClipRgn);
		TextFont(f);
		TextSize(s);
	end;

	procedure FindSelectedVariables (mat: TMatrixPtr;
									var whichXVariables, whichYVariable: TBoolVectorPtr;
									var yVarName: Str255);
		var
			j: TInteger;
			theCell: Point;
			nameLen: Integer;
	begin
{ Trouver la ou les variable(s) X slectionne(s) }
		whichXVariables := TBoolVectorPtr(NewPtrClear(mat^.p * SizeOf(Boolean)));
		if whichXVariables <> nil then
			for j := 1 to mat^.p do begin
				SetPt(theCell, 0, j - 1); { 0-based list indices }
				if (LGetSelect(false, theCell, gXVarSel)) then
					whichXVariables^[j] := true
				else
					whichXVariables^[j] := false;
			end; { for j }

{ Trouver la variable Y slectionne }
		whichYVariable := TBoolVectorPtr(NewPtrClear(mat^.p * SizeOf(Boolean)));
		if whichYVariable <> nil then begin
			SetPt(theCell, 0, 0);
			if LGetSelect(true, theCell, gYVarSel) then
				;
{ trouver le nom de la variable }
			nameLen := 255;  (* The maximum number of chars allowed in the string *)
			LGetCell(POINTER(ORD(@yVarName) + 1), nameLen, theCell, gYVarSel);        (* Get the text of the selected cell *)
   {$PUSH}
  {$R- Turn off range checking for the next operation, since Pascal doesn't like you to change the string length byte }
			yVarName[0] := CHR(nameLen);                        (* Set the length byte of the string *)
     {$POP Range checking is back on}

			for j := 1 to mat^.p do
				if (j - 1) = theCell.v then
					whichYVariable^[j] := true
				else
					whichYVariable^[j] := false;
		end; { if whichYVariable }

	end; { FindSelectedVariables }

	procedure RegressionOK;
		var
			wInfo: WindowInfoPtr;
			whichXVariables, whichYVariable: TBoolVectorPtr;
			display, oldWindow: WindowPtr;
			permMeth: TMethodePermutation;
			testMeth: TTest;
			root: TInteger;
			dummy: Integer;
			pMenu: MenuHandle;
			toRemove, toEnter: TReal;
			itemString, strTest, strVar, strPerm, strTime: Str255;
			printTime: Boolean;
			done, startTime, finishTime: LongInt;
			tir: TestInfoRecord;
{$ifc can_use_threads}
			err: OSErr;
			threadMade: ThreadID;
			options: ThreadOptions;
{$endc}
	begin
{ La touche "Option" est-elle enfonce? }
		printTime := OptionKeyDown;

		wInfo := WindowInfoPtr(WindowPeek(gRegDlg)^.refCon);
		Assert(wInfo^.owner = kSignature);

{ Paranoa de variables non-initialises... }
		whichXVariables := nil;
		whichYVariable := nil;

		FindSelectedVariables(wInfo^.matrix, whichXvariables, whichYVariable, strVar);
		if (whichXVariables <> nil) and (whichYVariable <> nil) then begin

			case gCurPermMeth of
				iPermVect: 
					permMeth := permVector;
				iPermMat: 
					permMeth := permMatrix;
				iPermDPT: 
					permMeth := permDouble;
				iPermTPT: 
					permMeth := permTriple;
			end; { case gCurPermMeth }

			case gCurTestMeth of
				iTestSimple: 
					testMeth := simple;
				iTestBack: 
					testMeth := backward;
				iTestForw: 
					testMeth := forward;
				iTestStep: 
					testMeth := stepwise;
			end; { case gCurTestMeth }

			root := GetIntegerDItem(gRegDlg, iRootingObj);

			dummy := GetIntegerDItem(gRegDlg, iPToRemove);
			pMenu := GetMenu(kPToRemoveMenu);
			GetMenuItemText(pMenu, dummy, itemString);
			if Length(itemString) > 0 then
				ReadString(itemString, toRemove);

			dummy := GetIntegerDItem(gRegDlg, iPToEnter);
			pMenu := GetMenu(kPToEnterMenu);
			GetMenuItemText(pMenu, dummy, itemString);
			if Length(itemString) > 0 then
				ReadString(itemString, toEnter);

{ Create a new display window for output }
			Display := GetNewDWindow(kDisplayWinRes, WindowPtr(-1));
			SetDWindowBanner(Display, kProgressBannerHeight);
			SetDWindowUpdate(Display, @DWindowProgress);
{ 27/04/99 PhC: this line was commented out, and I can't figure out why I did that. }
{ so I am un-commenting it... }
			SetDWindowClose(Display, @CloseFrontWindow);
{ set name, etc... }
			SetDWindow(Display); { use this window as current display window }
			strTest := GetTextDItem(gRegDlg, gCurTestMeth);
			strPerm := GetTextDItem(gRegDlg, gCurPermMeth);
			strTest := Concat(strTest, ' on ', strVar, ' (', strPerm, ')');
			SetWTitle(Display, strTest);
{ Initialize banner }
			DWindowProgress;


{ If one wants to print the starting time, do so }
			if printTime then begin
				GetDateTime(startTime);
				IUTimeString(startTime, true, strTime);
				DisplayString('Start time: ', nil);
				DisplayStringLn(strTime, nil);
				DisplayLn(nil);
			end; { if }

{ close the selection window so as not to clutter the screen }
{RegressionWindowClose;}
			done := 0;
{ Initialize test info record }
			tir.permMeth := permMeth;
			tir.root := root;
			tir.nbPerm := gNbPerm;
			tir.testMeth := testMeth;
			tir.pToRemove := toRemove;
			tir.pToenter := toEnter;
			tir.mat := wInfo^.matrix;
			tir.whichXVariables := whichXVariables;
			tir.whichYVariable := whichYVariable;
			New(tir.progress);
			Assert(tir.progress <> nil);
			tir.progress^.displayWindow := display;
			tir.progress^.useThreads := gUseThreads;
{$ifc can_use_threads}
{ save FPU context on 68k+FPU Macs }
{$ifc __MC68881__}
			options := kCreateIfNeeded;
{$elsec}
			options := kFPUNotNeeded + kCreateIfNeeded;
{$endc}

			if gUseThreads then begin
				err := NewThread(kCooperativeThread, ThreadEntryProcPtr(@FaireTests), @tir, 0, options, done, threadMade);
				while (done = 0) do
					err := YieldToAnyThread;
			end
			else
				done := FaireTests(@tir);
{$elsec}
			done := FaireTests(@tir);
{$endc}

{ Don't dispose of pointers this time, the test procedure will take care of that }
{ since it can take a long time and we may want to yield time to get back in the }
{ event loop... }

			Dispose(tir.progress);

{ If one wants to print the finish time, do so }
			if printTime then begin
				GetDWindow(oldWindow);
				SetDWindow(Display); { Make sure we're still the current DisplayWindow }
				GetDateTime(finishTime);
				IUTimeString(finishTime, true, strTime);
				DisplayLn(nil);
				DisplayString('Finish time: ', nil);
				DisplayStringLn(strTime, nil);
				DisplayLn(nil);
				DisplayString('Total elapsed time: ', nil);
				DisplayLong(finishTime - startTime, nil);
				DisplayStringLn(' seconds', nil);
				SetDWindow(oldWindow);
			end; { if }

		end; { if }
	end;

	procedure SpawnThread (p: ProcPtr);
{$ifc can_use_threads}
		var
			err: OSErr;
			threadMade: ThreadID;
			options: ThreadOptions;
			ignore: LongInt;
{$endc}

{$IFC GENERATINGPOWERPC}
		procedure CallPnoarg (myProc: ProcPtr);
			var
				tempUPP: UniversalProcPtr;
		begin
			tempUPP := NewFKEYProc(FKEYProcPtr(myProc));
			CallFKEYProc(tempUPP);
			DisposePtr(Ptr(tempUPP));
		end;
{$ELSEC}
{68k}
		procedure CallPnoarg (myProc: ProcPtr);
		inline
			$205f, $4e90;
{$ENDC}

	begin
{$ifc can_use_threads}
{ save FPU context on 68k+FPU Macs }
{$ifc __MC68881__}
		options := kCreateIfNeeded;
{$elsec}
		options := kFPUNotNeeded + kCreateIfNeeded;
{$endc}
		if gUseThreads then begin
			err := NewThread(kCooperativeThread, ThreadEntryProcPtr(p), nil, 0, options, ignore, threadMade);
			err := YieldToAnyThread;
		end
		else
			CallPnoarg(p);
{$elsec}
		CallPnoarg(p);
{$endc}
	end; { SpawnThread }

	procedure RegressionWindowFilter (dlg: DialogPtr;
									var theEvent: EventRecord;
									var result: Boolean);
		var
			theKey: Char;
			box: Rect;
			wInfo: WindowInfoPtr;
			curFont, curSize: Integer;
			s: Str255;
			oldPort: GrafPtr;
	begin
		wInfo := WindowInfoPtr(WindowPeek(dlg)^.refCon);
		Assert(wInfo^.owner = kSignature);

{		StringToNum(GetTextDItem(dlg, iNbPerm), gNbPerm);}
{gNbPerm := 0;}
		s := GetTextDItem(dlg, iNbPerm);
		if Length(s) > 0 then
			StringToNum(s, gNbPerm);{    ReadString(s, gNbPerm);}
		result := false;
		if (theEvent.what = keyDown) or (theEvent.what = autoKey) then begin
			theKey := char(BitAnd(theEvent.message, charCodeMask));
			if (theKey = kReturn) or (theKey = kEnter) then
				if TestDItemEnable(dlg, ok) then begin
					FlashDialogItem(dlg, ok);
					result := true;
					SpawnThread(@RegressionOK);
				end;
		end;

		if theEvent.what = updateEvt then begin
			GetPort(oldPort);
			BeginUpdate(dlg);
			SetPort(dlg);
			EraseRect(dlg^.portRect);

{ Lists }
			LUpdate(dlg^.visRgn, gXVarSel);           (* Draw the first list *)
			LUpdate(dlg^.visRgn, gYVarSel);           (* Draw the second list *)
			curFont := gRegDlg^.txFont;
			curSize := gRegDlg^.txSize;
			TextFont(gListFont);
			TextSize(gListSize);
			LUpdate(dlg^.visRgn, gQuickTest);           (* Draw the results list *)
			TextFont(curFont);
			TextSize(curSize);
			box := GetDItemBox(dlg, iIndependentList); (* Frame the first list *)
			InsetRect(box, -1, -1);
			box.right := box.right - 15;
			FrameRect(box);

			box := GetDItemBox(dlg, iDependentList); (* Frame the second list *)
			InsetRect(box, -1, -1);
			box.right := box.right - 15;
			FrameRect(box);

			box := GetDItemBox(dlg, iQuickResults); (* Frame the results list *)
			InsetRect(box, -1, -1);
			box.right := box.right - 15;
			FrameRect(box);

			if TestConditions(wInfo^.matrix) then begin
				EnableDItem(dlg, iQuickTest);
				if (gNbPerm > 0) and (gNbPerm < MaxLongInt) then
					EnableDItem(dlg, ok);
			end
			else begin
				DisableDItem(dlg, iQuickTest);
				DisableDItem(dlg, ok);
			end;

			DrawDialog(dlg);

{ OK button }
			box := GetDItemBox(dlg, ok);
			InsetRect(box, -4, -4);
			PenSize(3, 3);
			if not TestDItemEnable(dlg, ok) then
{$IFC not undefined THINK_PASCAL}
				PenPat(gray);
{$ELSEC}
			PenPat(qd.gray);
{$ENDC}
			FrameRoundRect(box, 15, 15);
{$IFC not undefined THINK_PASCAL}
			PenPat(black);
{$ELSEC}
			PenPat(qd.black);
{$ENDC}
			PenSize(1, 1);

			EndUpdate(dlg);
			SetPort(oldPort);
			result := true;
		end;

	end; {RegressionWindowFilter}

	procedure RegressionWindowEvent (itemNum: integer;
									var theEvent: EventRecord);
		var
			localClick: Point;
			isDoubleClick: Boolean;
			wInfo: WindowInfoPtr;
			whichXVariables, whichYVariable: TBoolVectorPtr;
			curFont, curSize: Integer;
			dummyStr: Str255;

		procedure InvalButtons;
			var
				box: Rect;
		begin
			if TestDItemEnable(gRegDlg, iQuickTest) <> TestConditions(wInfo^.matrix) then begin
				box := GetDItemBox(gRegDlg, ok);
				InsetRect(box, -4, -4);
				InvalRect(box);
				InvalRect(GetDItemBox(gRegDlg, iQuickTest));
			end; { if conditions changed }
		end; { InvalButtons }

	begin
		wInfo := WindowInfoPtr(WindowPeek(gRegDlg)^.refCon);
		Assert(wInfo^.owner = kSignature);

		whichXVariables := nil;
		whichYVariable := nil;

		localClick := theEvent.where;
		GlobalToLocal(localClick);

		case theEvent.what of
			keyDown, autokey:  begin
				InvalButtons;
			end; { keyDown }

			mouseDown: 
				case itemNum of
					ok: 
						SpawnThread(@RegressionOK);

					cancel: 
						RegressionWindowClose;

					iQuickTest:  begin
						FindSelectedVariables(wInfo^.matrix, whichXvariables, whichYVariable, dummyStr);
						if (whichXVariables <> nil) and (whichYVariable <> nil) then begin
							DoQuickTest(wInfo^.matrix, whichXVariables, whichYVariable);
							DisposePtr(Ptr(whichXVariables));
							DisposePtr(Ptr(whichYVariable));
						end; { if }
					end; { iQuickTest }

					iPermVect..iPermTPT:  begin
						if gCurPermMeth = iPermTPT then
							DisableDItem(gRegDlg, iRootingObj);
						SetBooleanDItem(gRegDlg, gCurPermMeth, false);
						SetBooleanDItem(gRegDlg, itemNum, true);
						gCurPermMeth := itemNum;
						if gCurPermMeth = iPermTPT then
							EnableDItem(gRegDlg, iRootingObj);
					end; { perm meth }

					iTestSimple..iTestStep:  begin
						case gCurTestMeth of
							iTestBack: 
								DisableDItem(gRegDlg, ipToRemove);
							iTestForw: 
								DisableDItem(gRegDlg, ipToEnter);
							iTestStep:  begin
								DisableDItem(gRegDlg, ipToRemove);
								DisableDItem(gRegDlg, ipToEnter);
							end;
							otherwise
								;
						end; { case }

						SetBooleanDItem(gRegDlg, gCurTestMeth, false);
						SetBooleanDItem(gRegDlg, itemNum, true);
						gCurTestMeth := itemNum;

						case gCurTestMeth of
							iTestBack: 
								EnableDItem(gRegDlg, ipToRemove);
							iTestForw: 
								EnableDItem(gRegDlg, ipToEnter);
							iTestStep:  begin
								EnableDItem(gRegDlg, ipToRemove);
								EnableDItem(gRegDlg, ipToEnter);
							end;
							otherwise
								;
						end; { case }
					end; { test }

					iIndependentList:  begin
						isDoubleClick := LClick(localClick, theEvent.modifiers, gXVarSel); (* process the mouse click *)
						InvalButtons;
					end;
					iDependentList:  begin
						isDoubleClick := LClick(localClick, theEvent.modifiers, gYVarSel); (* process the mouse click *)
						InvalButtons;
					end;

					iQuickResults:  begin
						curFont := gRegDlg^.txFont;
						curSize := gRegDlg^.txSize;
						TextFont(gListFont);
						TextSize(gListSize);
						isDoubleClick := LClick(localClick, theEvent.modifiers, gQuickTest); (* process the mouse click *)
						TextFont(curFont);
						TextSize(curSize);
					end;

					otherwise
				end; {case}
			otherwise
		end; { case }

	end; {RegressionWindowEvent}

	procedure SetupRegressionWindow;
		var
			s: Str255;
			i, nVar: TInteger;
			m: MenuHandle;
			box, dataBounds: Rect;
			cellSize, theCell: Point;
			frontDataWindow: WindowPtr;
			wInfo: WindowInfoPtr;
			curFont, curSize: Integer;
	begin
		frontDataWindow := FrontWindow;

		if frontDataWindow <> nil then
			if gRegDlg = nil then begin
				gRegDlg := GetNewDialog(kRegDlogRes, nil, WindowPtr(-1));
				if gRegDlg <> nil then begin
					if noErr = SetDialogDefaultItem(gRegDlg, ok) then
						;

{ Je dsactive le bouton "Stepwise" puisque cette procdure ne fonctionne pas encore }
					DisableDItem(gRegDlg, iTestStep);

					if SkelDialog(gRegDlg, @RegressionWindowEvent, nil, nil, @RegressionWindowFilter) then
						;

					wInfo := WindowInfoPtr(WindowPeek(frontDataWindow)^.refCon);
					Assert(wInfo^.owner = kSignature);
{ Jam this refCon in the dialog's refCon }
					SetWRefCon(gRegDlg, LongInt(wInfo));

{ Set up dialog info }
					if wInfo^.matrix^.nbObjets > 0 then begin { On a peut-tre affaire  une matrice de distances }
{ Construire le menu des objets au cas o l'usager dsire faire du DPT }
						m := GetMenu(kRootObjMenu); { Get the menu }
						if CountMItems(m) > 0 then { Delete its contents if any }
							for i := CountMItems(m) downto 1 do
								DeleteMenuItem(m, i);
						for i := 1 to wInfo^.matrix^.nbObjets do begin
{							NumToString(i, s);}
							s := StringOf(i);
							AppendMenu(m, s);
						end; { for i }
					end
					else begin { Dsactiver les 3 modes de permutations matricielles }
						DisableDItem(gRegDlg, iPermMat);
						DisableDItem(gRegDlg, iPermDPT);
						DisableDItem(gRegDlg, iPermTPT);
					end; { else }
					SetBooleanDItem(gRegDlg, iPermVect, true); { Slectionner les permutations mode vecteur }
					gCurPermMeth := iPermVect;
					DisableDItem(gRegDlg, iRootingObj); { Sera ractiv si l'usager choisis TPT }

					SetBooleanDItem(gRegDlg, iTestSimple, true);
					gCurTestMeth := iTestSimple;
					DisableDItem(gRegDlg, ipToRemove);
					DisableDItem(gRegDlg, ipToEnter);

					SelectDialogItemText(gRegDlg, iNbPerm, 0, MaxInt);

					DisableDItem(gRegDlg, iQuickTest); { No quick test allowed yet }

					DisableDItem(gRegDlg, ok); { No variables selected, can't go }

{ Set up the lists }
					nVar := wInfo^.matrix^.p; { Number of columns in data matrix }

					box := GetDItemBox(gRegDlg, iIndependentList); (* This rectangle will hold a list variable names *)
					SetRect(dataBounds, 0, 0, 1, nVar); (* Specify an initial list that's 1 column wide by nVar rows deep *)
					SetPt(cellSize, 0, 0);           (* Let the list manager calculate the cell size *)
	(*-------------------------------------------------------------------------------------*)
	(* Create an empty list, 0 rows by 1 column                                            *)
	(*-------------------------------------------------------------------------------------*)
					box.right := box.right - 16; (* The rectangle passed to LNew determines the size of the body *)
	                                 (* of the list; scroll bars are placed outside of the rectangle *)
	                                 (* Therefore, you should set your rectangle for the proper size *)
	                                 (* including the scroll bars, and adjust it before creating the *)
	                                 (* list.                                                        *)
    	(* Create the list with the given physical boundaries, size,    *)
		(* and options.  Note that it has to be attached to a window (a *)
		(* dialog or alert will also work *)
					gXVarSel := LNew(box, dataBounds, cellSize, 0, gRegDlg, notDrawn, noGrow, noHScroll, vScroll);
					gXVarSel^^.selFlags := lDoHAutoscroll + lDoVAutoscroll + lExtendDrag;    (* Set the options for this list *)

{ Create the dependent variable list. Note the slightly different selFlags, i.e. you can only select }
{one dependent variable, whereas you could select as many independents as you wanted }
					box := GetDItemBox(gRegDlg, iDependentList);
					SetRect(dataBounds, 0, 0, 1, nVar);
					SetPt(cellSize, 0, 0);
					box.right := box.right - 16;
					gYVarSel := LNew(box, dataBounds, cellSize, 0, gRegDlg, notDrawn, noGrow, noHScroll, vScroll);
					gYVarSel^^.selFlags := lDoHAutoscroll + lDoVAutoscroll + lOnlyOne;

{ Create the results list, which initially contains only a status message }
					box := GetDItemBox(gRegDlg, iQuickResults);
					SetRect(dataBounds, 0, 0, 1, 1);
					SetPt(cellSize, 0, 0);
					box.right := box.right - 16;
					box.bottom := box.bottom - 16;

					curFont := gRegDlg^.txFont;
					curSize := gRegDlg^.txSize;
					TextFont(gListFont);
					TextSize(gListSize);
					gQuickTest := LNew(box, dataBounds, cellSize, 0, gRegDlg, notDrawn, noGrow, hScroll, vScroll);
					gQuickTest^^.selFlags := lDoHAutoscroll + lDoVAutoscroll + lExtendDrag;
					TextFont(curFont);
					TextSize(curSize);

{ Set the values of the list elements to the matrix column names }
					for i := 1 to nVar do begin { careful of 0-based indices }
						s := GetColName(wInfo^.matrix, i);
						SetPt(theCell, 0, i - 1); (* select the proper cell *)
						LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gXVarSel); { Copy info in both lists }
						LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gYVarSel);
					end;
					GetIndString(s, kResStrings, kQuickTestMessage); { Status message }
					SetPt(theCell, 0, 0); (* select the proper cell *)
					LSetCell(POINTER(ORD(@s) + 1), length(s), theCell, gQuickTest);

					LSetDrawingMode(TRUE, gXVarSel); { Turn drawing back on }
					LSetDrawingMode(TRUE, gYVarSel);
					LSetDrawingMode(TRUE, gQuickTest);

				end; { if <> nil }

			end; { if =nil }

		ShowWindow(gRegDlg);
		SelectWindow(gRegDlg);

{$IFC not undefined THINK_PASCAL}
		SetCursor(arrow);
{$elsec}
		SetCursor(qd.arrow);
{$endc}

	end; { SetupRegressionWindow }

	function GetListBox (w: WindowPtr): Rect;
		var
			r: Rect;
	begin
		Assert(w <> nil);
		r := w^.portRect;
		r.top := r.top + kHeaderHeight; { Leave room for header }
		GetListBox := r;
	end; { GetListBox }

	procedure FileWindowIdle;
	begin
	end; { FileWindowIdle }

	procedure FileWindowActivate (active: Boolean);
	begin
{$UNUSED active}
	end; { FileWindowActivate }

	procedure HeaderUpdate (drawRect: Rect;
									wInfo: WindowInfoPtr);
		var
			s1, s2, s3: Str255;
			f: FontInfo;
			lineHeight: Integer;
	begin
		GetClip(gClipRgn);
		ClipRect(drawRect);

{ Header information }
		GetIndString(s2, kFileWindowStrings, kLinesStr);
		s1 := StringOf(wInfo^.matrix^.n : 1, s2);
		GetIndString(s2, kFileWindowStrings, kColumnsStr);
		s1 := StringOf(s1, wInfo^.matrix^.p : 1, s2);
		if wInfo^.matrix^.nbObjets > 0 then
{			NumToString(wInfo^.matrix^.nbObjets, s2)}
			s2 := StringOf(wInfo^.matrix^.nbObjets)
		else
			GetIndString(s2, kResStrings, knaStr);
		GetIndString(s3, kFileWindowStrings, kNbObjectsStr);
		s3 := Concat(s3, s2);
{ Now, s1 contains the row/col information and s3 the # of objects information }
{ So let's draw it! }
		GetFontInfo(f);
		lineHeight := f.ascent + f.descent + f.leading;
		MoveTo(kHOffset, kVOffset + f.ascent);
		DrawString(s1);
		MoveTo(kHOffset, kVOffset + 2 * lineHeight);
		DrawString(s3);

		SetClip(gClipRgn);
	end; { HeaderUpdate }

	procedure FileWindowUpdate (resized: Boolean);
		var
			box: Rect;
			wInfo: WindowInfoPtr;
			curFont, curSize: Integer;
			curWindow: WindowPtr;
	begin
{$IFC not undefined THINK_PASCAL}
		curWindow := thePort;
{$ELSEC}
		curWindow := qd.thePort;
{$ENDC}
		wInfo := WindowInfoPtr(WindowPeek(curWindow)^.refCon);
		Assert(wInfo^.owner = kSignature);

		EraseRect(curWindow^.portRect);

		box := curWindow^.portRect;
		box.bottom := box.top + kHeaderHeight;
		HeaderUpdate(box, wInfo);

		box := GetListBox(curWindow);

		if resized then begin
			LSize(box.right - box.left - 16, box.bottom - box.top - 16, wInfo^.list);
		end; { if resized }

		curFont := curWindow^.txFont;
		curSize := curWindow^.txSize;
		LUpdate(curWindow^.visRgn, wInfo^.list);
		TextFont(curFont);
		TextSize(curSize);
		InsetRect(box, -1, -1);
		box.right := box.right - 15;
		box.bottom := box.bottom - 15;
		FrameRect(box);
{ Draw the grow box only in that corner, no extra lines }
		box := curWindow^.portRect;
		box.left := box.right - 15;
		box.top := box.bottom - 15;
		GetClip(gClipRgn);
		ClipRect(box);
		DrawGrowIcon(curWindow);
		SetClip(gClipRgn);
	end; { FileWindowUpdate }

	procedure FileWindowMouse (thePoint: Point;
									theTime: LongInt;
									theMods: Integer);
		var
			isDoubleClick: Boolean;
			wInfo: WindowInfoPtr;
			curFont, curSize: Integer;
			curWindow: WindowPtr;
{$UNUSED theTime}
	begin
{$IFC UNDEFINED THINK_PASCAL}
		curWindow := qd.thePort;
{$ELSEC}
		curWindow := thePort;
{$ENDC}
		wInfo := WindowInfoPtr(WindowPeek(curWindow)^.refCon);
		Assert(wInfo^.owner = kSignature);

		curFont := curWindow^.txFont;
		curSize := curWindow^.txSize;
		if PtInRect(thePoint, GetListBox(curWindow)) then
			isDoubleClick := LClick(thePoint, theMods, wInfo^.list);
		TextFont(curFont);
		TextSize(curSize);
	end; { FileWindowMouse }

	function SetOptimalCellSize: Cell;
		const
			m = 'm'; {typical largest width in a font }
			indent = 2;
		var
			c: Cell;
	begin
		SetPt(c, 50, 20);
		SetOptimalCellSize := c;
	end; { SetOptimalCellSize }

	procedure SetupFileWindow (filename: Str255;
									wInfo: WindowInfoPtr);
		var
			box, dataBounds: Rect;
			cellSize: Point;
			callLDEFProc: UniversalProcPtr;
			newWin: WindowPtr;
			curFont, curSize: Integer;
	begin
		Assert(wInfo <> nil);
		newWin := GetNewWindow(kFileWinRes, nil, WindowPtr(-1));
		if newWin <> nil then
			if SkelWindow(newWin, @FileWindowMouse, nil, @FileWindowUpdate, @FileWindowActivate, @CloseFrontWindow, nil, @FileWindowIdle, true) then
				;

		SetWRefCon(newWin, longInt(wInfo));
{ Set up window info }
		SetWTitle(newWin, filename);

{ Create new list for display of data }
		box := GetListBox(newWin);
		box.right := box.right - 16; { Leave room for vert. scroll bar }
		box.bottom := box.bottom - 16; { Leave room for horiz. scroll bar }
		SetRect(dataBounds, 0, 0, wInfo^.matrix^.p, wInfo^.matrix^.n + 1); { +1 b/c element 0 is var name }
		curFont := newWin^.txFont;
		curSize := newWin^.txSize;
		TextFont(gListFont);
		TextSize(gListSize);
{ Figure out the optimal size and height given current font and size }
		cellSize := SetOptimalCellSize;
		wInfo^.list := LNew(box, dataBounds, cellSize, kStubLDEF, newWin, notDrawn, noGrow, hScroll, vScroll);
		wInfo^.list^^.selFlags := lDoHAutoscroll; {+ lDoVAutoscroll}
		TextFont(curFont);
		TextSize(curSize);
{ Must set the refcon of the list to actual ldef proc in my app }
{$IFC UNDEFINED THINK_PASCAL}
		callLDEFProc := NewListDefProc(MatrixDisplayLDEF);
{$ELSEC}
		callLDEFProc := @MatrixDisplayLDEF;
{$ENDC}
		wInfo^.list^^.refCon := longint(callLDEFProc);

		LSetDrawingMode(true, wInfo^.list);
		ShowWindow(newWin);
		SelectWindow(newWin);

	end; { SetupFileWindow }

	function OpenFile (fss: FSSpecPtr): OSErr;
		var
			fName, s: Str255;
			s10: TString;
			unCar: Char;
			f: text;
			i, j, nLignes, nColonnes: TInteger;
			entetesColonnes: Boolean;
			val: TReal;
			wInfo: WindowInfoPtr;
			compte: Integer;
	begin
		OpenFile := noErr; { so far... }
		SetCursor(GetCursor(watchCursor)^^);
		fName := GetFullPath(fss^);
		Reset(f, fName);
{ Trouver s'il y a des en-ttes de colonnes }
		ReadLn(f, s);
		if Length(s) > 0 then
			entetesColonnes := True
		else
			entetesColonnes := False;
{ Passer  la deuxime ligne }
		if not Eof(f) then begin { Il y a autre chose  lire, c'est normal }
{ Compter le nombre de colonnes }
			nColonnes := 0;
			repeat
				Read(f, val);
				nColonnes := nColonnes + 1;
			until EoLn(f);
			ReadLn(f);
{ Troisime ligne et plus }
			nLignes := 1; { Parce qu'on a lu la ligne ci-haut et qu'elle doit contenir des donnes }
			repeat
				ReadLn(f, s);
				if Length(s) > 0 then { Pas une ligne vide }
					nLignes := nLignes + 1;
			until eof(f);
			Reset(f);
			wInfo := WindowInfoPtr(NewPtrClear(SizeOf(WindowInfo)));
			Assert(wInfo <> nil);
			wInfo^.owner := kSignature;
			wInfo^.matrix := nil;
			wInfo^.list := nil;

			if NewMatrix(wInfo^.matrix, nLignes, nColonnes, TRUE, TRUE, permNone, matRect) then begin
				for j := 1 to nColonnes do begin
					unCar := ' ';
					s10 := ''; { Utilisation d'un Str10 plutt qu'un Str255 pour viter les problmes d'assignation dans SetColName }
					compte := 0;
					while (unCar <> kTab) do begin
						Read(f, unCar);
						compte := compte + 1;
						if (unCar <> kTab) and (compte <= 10) then
							s10 := Concat(s10, unCar);
						if EoLn(f) then
							unCar := kTab;
					end; { while }
					SetColName(wInfo^.matrix, j, s10);
				end;
{ Lecture des donnes dans les lignes 2->nLignes }
				for i := 1 to nLignes do begin
					for j := 1 to nColonnes do begin
						Read(f, val);
						SetElement(wInfo^.matrix, i, j, val);
					end; { for j }
					ReadLn(f);
				end; { for i }

				SetupFileWindow(fss^.name, wInfo);
			end
			else
				OpenFile := memFullErr;{MyDebugStr('Not enough memory NewMatrix Open');}
		end; { if not Eof }

		Close(f);
{$IFC UNDEFINED THINK_PASCAL}
		SetCursor(qd.arrow);
{$elsec}
		SetCursor(arrow);
{$endc}
	end; { OpenFile }

{ Save a display window in a file }
	procedure SaveDWindow (w: WindowPtr);
		var
			reply: StandardFileReply;
			prompt, defaultName: Str255;
			err: OSErr;
			refNum: Integer;
			inOutCount: LongInt;
			te: TEHandle;
	begin
		GetIndString(prompt, kFileWindowStrings, kSaveFilePromptStr);
		GetWTitle(w, defaultName); { Default name: name of window! }
		if ChoisisFichier(reply, true, 0, nil, prompt, defaultName) then begin { write out the file }

			err := FSpCreate(reply.sfFile, 'R*ch', 'TEXT', reply.sfScript);
			err := FSpOpenDF(reply.sfFile, fsCurPerm, refNum);

			te := GetDWIndowTE(w);
			HLock(te^^.hText);
			inOutCount := te^^.teLength;
			err := FSWrite(refNum, inOutCount, te^^.hText^);
			HUnlock(te^^.hText);

			err := FSClose(refNum);
		end; { if sfGood }
	end; { SaveDWindow }

{ Print a display window }
	procedure PrintDWindow (w: WindowPtr);

		var
			te: TEHandle;
			oldPort: GrafPtr;
{ This is necessary for changes in the Universal Interfaces. }
{$ifc undefined THINK_PASCAL}
			printPort: TPPrPortRef;
{$elsec}
			printPort: TPPrPort;
{$endc}
			prStatus: TPrStatus;
			pageRect, destRect: Rect;
			copies, firstPage, lastPage, numberOfCopies, pageNumber, realNumberOfPagesInDoc: Integer;

		procedure FramePage (w: WindowPtr;
										pageRect: Rect);
			var
				theTitle, theDate, theTime: Str255;
				rawSecs: LongInt;
				oldFace: Style;
				fInfo: FontInfo;
				penPt: Point;
		begin
			FrameRoundRect(pageRect, 16, 16);
			{$ifc undefined THINK_PASCAL}
			oldFace := qd.thePort^.txFace;
			{$elsec}
			oldFace := thePort^.txFace;
			{$endc}
			TextFont(applFont); { Geneva }
			TextSize(10);
			TextFace([bold]);
			GetFontInfo(fInfo);
{ Draw window title, left aligned, up }
			MoveTo(20, ((kPrintHeaderHeight div 2) - (fInfo.ascent + fInfo.descent)) div 2 + fInfo.ascent);
			GetPen(penPt);
			GetWTitle(w, theTitle);
			DrawString(theTitle);
{ Draw time, right aligned, up }
			GetDateTime(rawSecs);
			IUTimeString(rawSecs, TRUE, theTime); { want secs }
			MoveTo(pageRect.right - StringWidth(theTime) - 20, penPt.v);
			DrawString(theTime);
{ Draw date, right aligned, down }
			penPt.v := penPt.v + fInfo.ascent + fInfo.descent + fInfo.leading; { one line down }
			IUDateString(rawSecs, longDate, theDate);
{$PUSH}
{$R-}
			if theDate[Length(theDate)] = ' ' then
				theDate[0] := Chr(Length(theDate) - 1); { remove trailing space }
{$POP}
			MoveTo(pageRect.right - StringWidth(theDate) - 20, penPt.v);
			DrawString(theDate);
{ Draw dividing line }
			MoveTo(0, kPrintHeaderHeight);
			LineTo(pageRect.right, kPrintHeaderHeight);
			TextFace(oldFace);
		end; { FramePage }

		procedure CenterRect (inRect: Rect;
										var dest: Rect;
										centerH, centerV: Boolean);
			var
				extra: Integer;
		begin
	{ align tops }
			dest.top := inRect.top;
			if centerH then begin
				extra := ((inRect.right - inRect.left) - (dest.right - dest.left)) div 2;
				if extra < 0 then
					extra := 0;
				dest.left := dest.left + extra;
				dest.right := dest.right + extra;
			end;
			if centerV then begin
				extra := ((inRect.bottom - inRect.top) - (dest.bottom - dest.top)) div 2;
				if extra < 0 then
					extra := 0;
				dest.top := dest.top + extra;
				dest.bottom := dest.bottom + extra;
			end;
		end; { CenterRect }

{ Inset the page rect by enough to allow for a header }
		function GetPrintRect (wholePage: Rect): Rect;
			var
				r: Rect;
		begin
			r := wholePage;
			r.top := wholePage.top + kPrintHeaderHeight; { so we don't draw in the header }
			InsetRect(r, kPrintInset, kPrintInset);
			GetPrintRect := r;
		end; { GetPrintRect }

		function GetNextStart (r: rect;
										startLine: integer;
										te: TEHandle): Integer;
			var
				height, endLine: Integer;
		begin
			with r do
				height := bottom - top;
			endLine := startLine;
			while (endLine <= te^^.nLines) & (TEGetHeight(endLine, startLine, te) < height) do
				endLine := endLine + 1;
			GetNextStart := endline;
		end; { GetNextStart }

{ Count the number of pages in a window }
		function CountPages (te: TEHandle;
										r: Rect): Integer;
			var
				pageHeight, pageWidth, count, startLine: Integer;
		begin
			pageHeight := r.bottom - r.top;
			pageWidth := r.right - r.left;
			count := 0;
			startLine := 1;
			while startLine <= te^^.nLines do begin
				startLine := GetNextStart(r, startLine, te);
				count := count + 1;
			end;
			CountPages := count;
		end; { CountPages }

		procedure DrawPage (te: TEHandle;
										gp: grafPtr;
										pageRect: Rect;
										page: Integer);
			var
				startLine, endLine, i, offset: Integer;
				oldInPort, oldPort: GrafPtr;
				vr, dr: Rect;
		begin
			GetPort(oldPort);
			SetPort(gp);

			oldInPort := te^^.inPort;
			te^^.inPort := gp;
			vr := te^^.viewRect;
			dr := te^^.destRect;
			startLine := 1;
			for i := 1 to page - 1 do
				startLine := GetNextStart(pageRect, startLine, te);
			endLine := GetNextStart(pageRect, startLine, te) - 1;
			pageRect.bottom := pageRect.top + TEGetHeight(endLine, startLine, te);
			if startline = 1 then
				offset := 0
			else
				offset := TEGetHeight(startLine - 1, 1, te);
			te^^.viewRect := pageRect;
			te^^.destRect.left := pageRect.left;
			te^^.destRect.right := pageRect.right;
			te^^.destRect.top := te^^.viewRect.top - offset;
			TEUpdate(pageRect, te);
			te^^.viewRect := vr;
			te^^.destRect := dr;
			te^^.inPort := oldinport;

			SetPort(oldPort);
		end; { DrawPage }

	begin
	{ Prints a TextEdit record }
	{ Assumes that the gPageSetup variable was correctly initialized through a PrJobDialog call }
		te := GetDWindowTE(w);
		GetPort(oldPort);
		PrOpen;
{ Set up the page and print rectangles; they may be different if we have a page header }
		pageRect := gPageSetup^^.prInfo.rPage;
		destRect := GetPrintRect(pageRect);
		realNumberOfPagesinDoc := CountPages(te, destRect);
{  Get the number of copies of the document that the user wants }
{  printed from iCopies of the TPrJob record (IM II-151). }
		numberOfCopies := gPageSetup^^.prJob.iCopies;
{ Get the first and last pages of the document that }
{ were requested to be printed by the user from }
{ iFstPage and iLastPage from the TPrJob record (IM II-151).}
		firstPage := gPageSetup^^.prJob.iFstPage;
		lastPage := gPageSetup^^.prJob.iLstPage;
		if (realNumberOfPagesinDoc < lastPage) then
			lastPage := realNumberOfPagesinDoc;
{ Print the number of copies of the document}
{ requested by the user from the Print Job Dialog.}
		for copies := 1 to numberOfCopies do begin
			printPort := PrOpenDoc(gPageSetup, nil, nil);
			SetPort(GrafPtr(printPort));
			SetCursor(GetCursor(watchCursor)^^); { indicate this may take some time }
			pageNumber := firstPage;
			while (pageNumber <= lastPage) do begin
				PrOpenPage(printPort, nil); { Open this page }
				if (PrError = noErr) then begin
					FramePage(w, pageRect);
					DrawPage(te, GrafPtr(printPort), destRect, pageNumber);
				end; { if not PrError }
				PrClosePage(printPort); { Close this page }
				pageNumber := pageNumber + 1;
			end;  { while pageNumber }
 { end of the printing loop }
			{$ifc undefined THINK_PASCAL}
			SetCursor(qd.arrow);
 			{$elsec}
			SetCursor(arrow);
			{$endc}
			PrCloseDoc(printPort);
		end; { for copies }
		{ Handle print spooler }
		if (gPageSetup^^.prJob.bJDocLoop = bSpoolLoop) and (PrError <> noErr) then
{ This is necessary for changes in the Universal Interfaces. }
{$ifc undefined THINK_PASCAL}
			PrPicFile(gPageSetup, nil, nil, nil, @prStatus);
{$elsec}
		PrPicFile(gPageSetup, nil, nil, nil, prStatus);
{$endc}
		PrClose;
		SetPort(oldPort);
	end; { PrintDWindow }

	procedure DoEditMenu (item: integer);
		var
			err: OSErr;
			te: TEHandle;
			minH, maxH, minV, maxV, i, j: Integer;
			c: Cell;
			data: Handle;
			s: Str255;
			size, curSize: Integer;
	begin
		case item of
			iUndo: 
				;
			iCut: 
				;
			iCopy:  begin
				err := ZeroScrap;
				if IsDWindow(FrontWindow) then begin { Display window }
					err := ZeroScrap;
					te := GetDWindowTE(FrontWindow);
					Assert(te <> nil);
					HLock(Handle(te^^.hText));
					err := PutScrap(te^^.teLength, 'TEXT', te^^.hText^);
					HUnLock(Handle(te^^.hText));
{    TECopy(GetDWindowTE(FrontWindow));}
				end { if IsDWindow }
				else if (FrontWindow = gRegDlg) then begin
					{ Allow users to copy data from the "Quick Test" result window }
					SetPt(c, 0, 0); { On commence au dbut }
{ 1) Trouver les extrmes vers la droite et le bas }
					minH := MaxInt;
					minV := MaxInt;
					maxH := 0;
					maxV := 0;
					while LGetSelect(true, c, gQuickTest) do begin
						if c.h < minH then
							minH := c.h;
						if c.v < minV then
							minV := c.v;
						if c.h > maxH then
							maxH := c.h;
						if c.v > maxV then
							maxV := c.v;
						c.h := c.h + 1; { prochaine cellule }
						if c.h >= gQuickTest^^.dataBounds.right then begin
							c.h := 0;
							c.v := c.v + 1;
						end;
					end;

					curSize := 0;
					data := NewHandleClear(curSize); { empty handle }
					for i := minV to maxV do
						for j := minH to maxH do begin
							c.h := j;
							c.v := i;
							s := '';
							if LGetSelect(false, c, gQuickTest) then begin { cell was selected }
								size := 255;
								LGetCell(@s[1], size, c, gQuickTest);
								{$push}
								{$r-}
								s[0] := Chr(size);
								{$pop}
							end; { if selected }

							if j = maxH then { ajouter return ou tab selon la position }
								s := Concat(s, kReturn)
							else
								s := Concat(s, kTab);

							size := Length(s);
							curSize := curSize + size;
							err := PtrAndHand(@s[1], data, size);
							if err <> noErr then
								MyDebugStr('Out of memory while copying to clipboard');

						end; { for j }

					HLock(data);
					err := ZeroScrap;
					err := PutScrap(curSize, 'TEXT', data^);
					HUnlock(data);
					DisposeHandle(data); { free memory }
				end; { gRegDlg }
			end; { iCopy }
			iPaste: 
				;
			iClear: 
				;
			iSelectAll:  begin
				if (FrontWindow = gRegDlg) then begin
					{ Select all data in the "Quick Test" result window }
					for i := gQuickTest^^.dataBounds.left to gQuickTest^^.dataBounds.right do
						for j := gQuickTest^^.dataBounds.top to gQuickTest^^.dataBounds.bottom do begin
							c.h := i;
							c.v := j;
							LSetSelect(true, c, gQuickTest);
						end;
				end; { gRegDlg }
			end; { iSelectAll }

			iPreferences: 
				if ChangePreferences then begin { Changer au besoin }
					GetFontAndSize(gListFont, gListSize);
					gNbDecimales := GetDecimals;
{$IFC UNDEFINED THINK_PASCAL}
					InvalRect(qd.screenBits.bounds);
{$ELSEC}
					InvalRect(screenBits.bounds);
{$ENDC}
				end;
			otherwise
				;
		end{case}
	end; { DoEditMenu }

	procedure DoFileMenu (item: integer);
		var
			reply: StandardFileReply;
			ignore: OSErr;
			typeList: SFTypeList;
	begin
		case item of
			iNew: 
				SetupRegressionWindow;

			iOpen:  begin
				typeList[0] := 'TEXT';
				if ChoisisFichier(reply, false, 1, @typeList, '', '') then
					ignore := OpenFile(@reply.sfFile);
			end; { iOpen }

			iClose: 
				CloseFrontWindow;

			iSave: 
				if IsDWindow(FrontWindow) then
					SaveDWindow(FrontWindow);

			iPageSetup:  begin
				PrOpen;
				if PrStlDialog(gPageSetup) then { ignore result }
					;
				PrClose;
			end; { iPageSetup }

			iPrint: 
				if IsDWindow(FrontWindow) then
					if (PrJobDialog(gPageSetup)) then
						PrintDWindow(FrontWindow);

			iQuit: 
				SkelWhoa;

			otherwise
				SkelWhoa;
		end{case}
	end; { DoFileMenu }

	procedure DoAbout;
	begin
		if 1 = Alert(kAboutRes, nil) then
			;
	end;

	procedure SetUpMenus;
		var
			aboutStr: Str255;
	begin
		GetIndString(aboutStr, kResStrings, kResAboutStr);
		SkelApple(aboutStr, @DoAbout);
		gFileMenu := GetMenu(kFileMenuRes);
		if SkelMenu(gFileMenu, @DoFileMenu, nil, false) then
			;										{Tell TransSkel to handle the menu}
		gEditMenu := GetMenu(kEditMenuRes);
		if SkelMenu(gEditMenu, @DoEditMenu, nil, true) then
			;										{Tell TransSkel to handle the menu}
	end;

	procedure InitFlags;
		var
			feature: LongInt;
	begin
		gColorFlag := false;
		if noErr = Gestalt(gestaltQuickdrawVersion, feature) then
			gColorFlag := feature > 0; {0 = non-color QD}
		gHas68kFPU := false;
		if noErr = Gestalt(gestaltFPUType, feature) then
			gHas68kFPU := feature > gestaltNoFPU; { We'll take any 68kFPU }

		gClipRgn := NewRgn;

		GetFontAndSize(gListFont, gListSize);
		gNbDecimales := GetDecimals;

	{ Default page setup }
		gPageSetup := THPrint(NewHandle(SizeOf(TPrint)));
		PrOpen; { Open printer driver }
		PrintDefault(gPageSetup); { Initialize the fields }
		if PRValidate(gPageSetup) then
			; { we don't care if it's valid or not... }
		PrClose; { close driver for now }

{ Use Thread manager? }
		gUseThreads := False;
{$ifc can_use_threads}
		if noErr = Gestalt(gestaltThreadMgrAttr, feature) then
			gUseThreads := feature > 0; { Test simply if thread manager is present }
{$endc}

		gMissingValueIndicator := -999; { should be read from prefs file, though }

	end; {InitFlags}

	procedure DoSuspendResume (isResume: Boolean);
	begin
		if isResume then
			SkelSetSleep(2) {Resume}
		else
			SkelSetSleep(20); {Suspend}
	end;

	procedure Background;
		var
{$ifc do_showmem}
			box: Rect;
			s: Str255;
			curPort: GrafPtr;
{$endc}
			err: OSErr;
			c: Cell;
	begin
{ Ajustement des menus }
		if FrontWindow <> nil then begin
			EnableItem(gFileMenu, iNew); { On a un fichier de donnes ouvert }
			EnableItem(gFileMenu, iClose);
		end
		else begin
			DisableItem(gFileMenu, iNew);
			DisableItem(gFileMenu, iClose);
		end;

		if IsDWindow(FrontWindow) then begin { Quelque chose  copier, enregistrer ou imprimer }
			EnableItem(gFileMenu, iSave);
			EnableItem(gFileMenu, iPrint);
			EnableItem(gEditMenu, iCopy);
		end
		else begin
			DisableItem(gFileMenu, iSave);
			DisableItem(gFileMenu, iPrint);
			DisableItem(gEditMenu, iCopy);
		end;

		if FrontWindow = gRegDlg then begin
			SetPt(c, 0, 0);
			if LGetSelect(true, c, gQuickTest) then
				EnableItem(gEditMenu, iCopy);
		end;

{$ifc can_use_threads}
		if gUseThreads then
			err := YieldToAnyThread;
{$endc}


{$ifc do_showmem}
			{Display free memory!}
			{Useful debug code when Lightsbug isn't around.}
		if (FrontWindow <> nil) then
			with FrontWindow^.portRect do begin
				SetRect(box, right - 50, 0, right, 12);
				GetPort(curPort);
				SetPort(FrontWindow);
				EraseRect(box);
				MoveTo(right - 50, 10);
				TextSize(9);
{				NumToString(FreeMem, s);}
				s := StringOf(FreeMem);
				DrawString(s);
				TextSize(0);
				SetPort(curPort);
			end;
{$endc}
	end; {Background}

begin
	SkelInit(6, nil);
	TransDisplayInit; { for display windows }
	SetUpMenus;
	InitFlags;
	SkelSetSuspendResume(@DoSuspendResume);
	SkelBackground(@Background);
	SkelSetSleep(2);
	SkelReqdAEInit(nil, @OpenFile, nil, nil);

{$ifc do_debugfiles}
	rewrite(debug1, 'debug 1');
	rewrite(debug2, 'debug 2');
{$endc}

	SkelMain;												{ loop til quit selected				}
	SkelClobber;											{ clean up								}

{$ifc do_debugfiles}
	close(debug1);
	close(debug2);
{$endc}

end.